package com.galaxis.manatee.constant;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zcj
 * @version 0.1
 * @date 2020/1/10 12:01 上午
 */
@Service
public class ChuanYunConstant {

    /**
     * 审核结束
     */
    public static final String FINISH = "1";

    /**
     * 审核流程中
     */
    public static final String IN_PROCESS = "2";

    /**
     * 生产项目项目类型
     */
    public static final String PRODUCTION_PROJECT = "生产项目";

    /**
     * 生产项目项目类型
     */
    public static final String SALES_PROJECT = "销售项目";

    /**
     * 生产项目项目类型
     */
    public static final String SALES_PROJECT_ID = "sales_project";

    /**
     * 生产项目类型项目号
     */
    public static final String PRODUCTION_PROJECT_ID = "production_project";

    /**
     * 默认工作组id
     */
    public static final String DEFAULT_WORK_GROUP = "defaultWorkgroup";

    /**
     * 默认工作组名称
     */
    public static final String DEFAULT_WORK_GROUP_NAME= "默认";

    /**
     * 保存项目号、项目ObjectId的映射关系
     */
    public static Map<String, String> PROJECT_CODE = new HashMap<>(2048);

    /**
     * 保存用户ID和工号的映射关系
     */
    public static Map<String, String> USER_EMPLOYEE_NUMBER = new HashMap<>(2048);

    /**
     * 保存用户id和所属部门id
     */
    public static Map<String, Object> USER_DEPARTMENT = new HashMap<>();

    /**
     * 用户ID和BG关系
     */
    public static Map<String, String> USER_BUSINESS_GROUP = new HashMap<>();

    /**
     * 调用地址
     */
    public static String CHUAN_YUN_INVOKE_URL;

    /**
     * 账号
     */
    public static String ENGINE_CODE;

    /**
     * 密码
     */
    public static String ENGINE_SECRET;

    @Value(value = "${chuanYun.engine.code}")
    public void setEngineCode(String engineCode) {
        ENGINE_CODE = engineCode;
    }

    @Value(value = "${chuanYun.engine.secret}")
    public void setEngineSecret(String engineSecret) {
        ENGINE_SECRET = engineSecret;
    }

    @Value(value = "${chuanYun.url.invoke}")
    public void setChuanYunInvokeUrl(String chuanYunInvokeUrl) {
        CHUAN_YUN_INVOKE_URL = chuanYunInvokeUrl;
    }


    /**
     * 实施项目
     */
    public static final String IMPLEMENTATION_PROJECT = "实施";

    /**
     * 维保项目
     */
    public static final String MAINTENANCE_PROJECT = "维保";

    /**
     * 研发二开项目
     */
    public static final String R_D_TWO_PROJECT = "研发二开";

    /**
     * 售后项目
     */
    public static final String AFTER_SALE_PROJECT = "售后";

    /**
     * 周填写方式
     */
    public static final String LOG_FILL_IN_WEEK = "每周填写";

    /**
     * 天填写方式
     */
    public static final String LOG_FILL_IN_DAY = "每天填写";

    /**
     * 每周工时
     */
    public static final String LOG_WEEKLY_HOURS = "每周工时";

    public static final List<String> NEED_WORK_GROUP_PROJECT_TYPE = Arrays.asList(IMPLEMENTATION_PROJECT, MAINTENANCE_PROJECT, R_D_TWO_PROJECT, AFTER_SALE_PROJECT);
    ;

    public static final List<String> LOG_WEEK_TYPE = Arrays.asList(LOG_FILL_IN_WEEK, LOG_WEEKLY_HOURS);


}
