package com.galaxis.manatee.dao;


import com.galaxis.manatee.capsule.util.GalaxisRepository;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunImplCostDO;
import org.springframework.stereotype.Repository;

import javax.transaction.Transactional;
import java.time.LocalDateTime;
import java.util.List;

/**
 * @author kxuan
 */
@Repository
public interface ChuanyunImplCostDao extends GalaxisRepository<ChuanyunImplCostDO, String> {

    ChuanyunImplCostDO findByProjectIdAndProjectCodeAndWorkGroup(String projectId, String projectCode, String workGroup);

    ChuanyunImplCostDO findByProjectIdAndProjectCodeAndWorkGroupAndLocalDate(String projectId, String projectCode, String workGroup, LocalDateTime localDate);

    ChuanyunImplCostDO findByProjectCodeAndWorkGroupAndLocalDate(String projectCode, String workGroup, LocalDateTime localDate);

    List<ChuanyunImplCostDO> findAllByProjectCode(String projectCode);

    @Transactional
    void deleteAllByProjectId(String projectId);

}
