package com.galaxis.manatee.entity.chuanyun.data.object;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.galaxis.manatee.util.ChuanyunLocalDateTimeDeserializer;
import com.galaxis.manatee.util.ChuanyunLocalDateTimeSerializer;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.extern.slf4j.Slf4j;

import javax.persistence.Column;
import javax.persistence.Entity;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * @author zcj
 * @version 0.1
 * @date 2020/5/9 10:41 上午
 */
@Slf4j
@Entity(name = "CHUANYUN_DAY_LOG")
@Data
@EqualsAndHashCode(callSuper = true)
@JsonIgnoreProperties(ignoreUnknown = true)
public class ChuanyunDayLog extends BasicSubDO{
    /**
     * 日期
     */
    @JsonSerialize(using = ChuanyunLocalDateTimeSerializer.class)
    @JsonDeserialize(using = ChuanyunLocalDateTimeDeserializer.class)
    private LocalDateTime dayLogDate;
    /**
     * 项目类型
     */
    @JsonProperty("projectType")
    private String projectType;
    /**
     * 项目Id
     */
    @JsonProperty("project")
    private String projectId;

    /**
     * 子项目ID
     */
    @JsonProperty("F0000066")
    private String subPorjectId;

    /**
     * 子项目编号
     */
    @JsonProperty("F0000071")
    private String subPorjectCode;

    /**
     * 子项目归属
     */
    @JsonProperty("F0000073")
    private String subProjectBg;

    /**
     * 项目Id字符串
     */
    @JsonProperty("projectId")
    private String projectIdString;
    /**
     * 工厂地址ID
     */
    @JsonProperty("factoryLocation")
    private String factoryLocationId;
    /**
     * 工厂地址ID
     */
    private String factoryLocationName;
    /**
     * 设备类型
     */
    @JsonProperty("F0000053")
    private String deviceType;
    /**
     * 订单号
     */
    @JsonProperty("F0000054")
    private String ticketId;
    /**
     * 生产项目工作内容
     */
    @JsonProperty("F0000055")
    private String jobContentId;

    private String jobContent;
    /**
     * 项目类日志的项目编号,工厂类项目的工厂编号
     */
    private String projectCode;
    /**
     * 工时
     */
    private BigDecimal hoursWorked;
    /**
     * 日志
     */
    @Column(length = Integer.MAX_VALUE)
    private String content;

    @JsonProperty("F0000087")
    private String workGroupId;

    private String workGroupName;
}
