package com.galaxis.manatee.service.impl;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.galaxis.manatee.dao.ChuanyunGroupProjectDao;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunGroupProjectDO;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunFindAllBizDTO;
import com.galaxis.manatee.entity.chuanyun.dto.Filter;
import com.galaxis.manatee.manager.ChuanYunManager;
import com.galaxis.manatee.service.GroupProjectService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Objects;

@Slf4j
@Service
public class GroupProjectServiceImpl implements GroupProjectService {

    @Autowired
    private ChuanYunManager chuanYunManager;

    @Autowired
    private ChuanyunGroupProjectDao chuanyunGroupProjectDao;

    @Override
    public List<ChuanyunGroupProjectDO> findAll() {
        return null;
    }

    @Override
    public List<ChuanyunGroupProjectDO> findByProjectCode(String projectCode) {
        List<String> m3 = List.of("F0000002_2," + projectCode);
        Filter instance = Filter.instance(0, 20, true, Filter.AND, m3);
        ChuanyunFindAllBizDTO<Object> groupProjectResponse = null;
        try {
            groupProjectResponse = chuanYunManager.findAll(ChuanyunGroupProjectDO.SCHEMA_CODE, instance);
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }
        if (Objects.isNull(groupProjectResponse) || !groupProjectResponse.getSuccessful() || groupProjectResponse.getReturnData() == null) {
            return null;
        }
        ObjectMapper objectMapper = new ObjectMapper();
        List<Object> bizObjectArray = groupProjectResponse.getReturnData().getBizObjectArray();
        List<ChuanyunGroupProjectDO> groupProjectDOList = objectMapper.convertValue(bizObjectArray, new TypeReference<>() {
        });
        return groupProjectDOList;
    }
}
