package com.galaxis.manatee.service.impl;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.galaxis.manatee.entity.chuanyun.data.object.BasicDO;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunBuildProject;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunProjectOrganizationStructureDO;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunFindAllBizDTO;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunFindAllBizReturnData;
import com.galaxis.manatee.entity.chuanyun.dto.Filter;
import com.galaxis.manatee.manager.ChuanYunManager;
import com.galaxis.manatee.service.ProjectOrganizationStructureService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Objects;

@Slf4j
@Service
public class ProjectOrganizationStructureServiceImpl implements ProjectOrganizationStructureService {

    @Autowired
    private ChuanYunManager chuanYunManager;

    @Override
    public List<ChuanyunProjectOrganizationStructureDO> findAllByProjectId(String projectId) {
        // projectId 为立项表中的主键id
        List<String> m1 = List.of("F0000001_2," + projectId);
        Filter filter = Filter.instance(0, 10, true, Filter.AND, m1);
        ChuanyunFindAllBizDTO<Object> projectList = null;
        try {
            projectList = chuanYunManager.findAll(ChuanyunProjectOrganizationStructureDO.SCHEMA_CODE, filter);
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }
        if (!Objects.isNull(projectList)) {
            ChuanyunFindAllBizReturnData<Object> returnData = projectList.getReturnData();
            if (projectList.getSuccessful() && !Objects.isNull(returnData)) {
                Object bizObject = returnData.getBizObjectArray();
                ObjectMapper objectMapper = new ObjectMapper();
                List<ChuanyunProjectOrganizationStructureDO> posList = objectMapper.convertValue(bizObject, new TypeReference<>() {
                });
                if (!posList.isEmpty()) {
                    return posList;
                }
            }
        }
        return null;
    }
}
